-- verificar se j foi gerado o ajuste no sistema ao importar (campo CODINVENTARIO) gravar na tabela de LANCTOESTOQ

create or replace
PROCEDURE MHA_IMPORTA_INVENT_ESTOQUE(XML_ARQ IN CLOB,
                                     P_ERRO OUT VARCHAR2,
                                     P_SEQLOG NUMBER DEFAULT -1)
IS
   L_XMLTYPE XMLTYPE;

   V_DTPROCESSA      DATE;
   V_IDLANCDTMAIFIL  VARCHAR2(1);
   V_IDLANCDTMAI     VARCHAR2(1);
   V_IDLANCDTMENFIL  VARCHAR2(1);
   V_IDLANCDTMEN     VARCHAR2(1);
   V_NRDIASAJUSFIL   FLOAT;
   V_NRDIASAJUS      FLOAT;
   V_NRDIASAJUSPDFIL FLOAT;
   V_NRDIASAJUSPD    FLOAT;
   V_CDPRODUTO       VARCHAR2(10);
   
   V_ERRO            VARCHAR2(1000);
   
   V_CODINVENTANT   VARCHAR2(10);
   V_NRLANCESTQ     VARCHAR2(20);
   V_NRSEQUITEM     NUMBER := 0;
   
   V_CDFILIAL       VARCHAR2(4);
   V_CODINVENTARIO  VARCHAR2(10);
   V_DATAEFETIVACAO DATE;
   V_CODPRODUTO     VARCHAR2(20);
   V_QUANTIDADE     VARCHAR2(20);
   V_QTDEVALOR      FLOAT;
   
   V_CDOPERADOR     VARCHAR2(12);
   V_IDORDIMPLANT   VARCHAR2(1);
   V_IDORDEMCLC     VARCHAR2(1);
   
   V_DATA           VARCHAR2(19);
   V_DESCERRO       VARCHAR2(1000);
   
   V_SEQLOGITEM   NUMBER;
   
   CURSOR C_INV_ESTOQUE IS
      SELECT F.CDFILIAL, X_N.CODINVENTARIO, TO_DATE(X_N.DATAEFETIVACAO), SUBSTR(X_N.CODPRODUTO, 1, 20), TO_BINARY_DOUBLE(REPLACE(X_N.QUANTIDADE, '.', ',')),
             R.CDOPERWMSMHA, NVL(R.IDORDIMPLANT, 'P') AS IDORDIMPLANT
        FROM XML_PARSE X,
             XMLTABLE('/InvenEstoq'
                      PASSING X.XML_INSERT
                      COLUMNS
                      "EMPRESA"         VARCHAR2(10) PATH '/InvenEstoq/EMPRESA'
                      ,"FILIAL"         VARCHAR2(10) PATH '/InvenEstoq/FILIAL'
                      ,"CODINVENTARIO"  VARCHAR2(10) PATH '/InvenEstoq/CODINVENTARIO'
                      ,"DATAEFETIVACAO" VARCHAR2(19) PATH '/InvenEstoq/DATAEFETIVACAO'
                      ,"DEPOSITO_ERP"   VARCHAR2(20) PATH '/InvenEstoq/DEPOSITO_ERP'
                      ,"CODPRODUTO"     VARCHAR2(40) PATH '/InvenEstoq/Itens/ItensSaldoProduto/CODPRODUTO'
                      ,"QUANTIDADE"     VARCHAR2(50) PATH '/InvenEstoq/Itens/ItensSaldoProduto/QUANTIDADE'
                      ) X_N,
             FILIAL F, PARAMFILIAL R
       WHERE R.CDFILWMSMHA = X_N.FILIAL
         AND R.CDFILIAL = F.CDFILIAL
         AND X_N.DEPOSITO_ERP IS NULL
       ORDER BY F.CDFILIAL, X_N.CODINVENTARIO;

   PROCEDURE INSERE_LOGITEM(P_SEQLOGITEM OUT NUMBER)
   IS
   BEGIN
      IF (P_SEQLOG > -1) THEN
         SELECT MAX(SEQLOGITEM)+1
           INTO P_SEQLOGITEM
           FROM USR_LOGITEM_INTEGRACAO;
         BEGIN
            INSERT INTO USR_LOGITEM_INTEGRACAO(SEQLOG, SEQLOGITEM, CDDADOS, HORAENV, HORAREC)
            VALUES(P_SEQLOG, P_SEQLOGITEM, V_CODINVENTARIO,  SYSDATE, SYSDATE);
         EXCEPTION
            WHEN OTHERS THEN
               P_SEQLOGITEM := NULL;
         END;
      ELSE
         P_SEQLOGITEM := NULL;
      END IF;
   END;   
BEGIN
   DELETE FROM XML_PARSE;
   L_XMLTYPE := XMLTYPE(XML_ARQ);
   INSERT INTO XML_PARSE(XML_INSERT) VALUES(L_XMLTYPE);
   COMMIT;

   V_CODINVENTANT := '0000000000';
   V_NRLANCESTQ   := '';

   OPEN C_INV_ESTOQUE;
   LOOP
      FETCH C_INV_ESTOQUE INTO V_CDFILIAL, V_CODINVENTARIO, V_DATAEFETIVACAO, V_CODPRODUTO, V_QUANTIDADE,
                               V_CDOPERADOR, V_IDORDIMPLANT;
      EXIT WHEN C_INV_ESTOQUE%NOTFOUND;
      
      V_DATA := TO_DATE(V_DATAEFETIVACAO);
      V_QTDEVALOR := TO_BINARY_DOUBLE(REPLACE(V_QUANTIDADE, '.', ','));
      
      -- Insere lanamento do inventrio
      IF V_CODINVENTANT <> V_CODINVENTARIO THEN
         V_ERRO := NULL;
         V_CODINVENTANT := V_CODINVENTARIO;
         
         BEGIN
            SELECT DECODE(PG.IDUTILDTPROC,'S',NVL(PF.DTPROCESSA, TO_DATE(SYSDATE)),TO_DATE(SYSDATE)) AS DTPROCESSA,
                   PF.IDLANCDTMAIFIL, PE.IDLANCDTMAI, PF.IDLANCDTMENFIL, PE.IDLANCDTMEN,
                   PF.NRDIASAJUSFIL, PE.NRDIASAJUS, PF.NRDIASAJUSPDFIL, PE.NRDIASAJUSPD
              INTO V_DTPROCESSA,
                   V_IDLANCDTMAIFIL, V_IDLANCDTMAI, V_IDLANCDTMENFIL, V_IDLANCDTMEN,
                   V_NRDIASAJUSFIL, V_NRDIASAJUS, V_NRDIASAJUSPDFIL, V_NRDIASAJUSPD
              FROM PARAMESTOQUE PE, PARAMGERAL PG, PARAMFILIAL PF
             WHERE PE.CDPARESTOQ = '1'
               AND PG.CDPARGERAL = '0001'
               AND PF.CDFILIAL = V_CDFILIAL;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_DTPROCESSA := SYSDATE;
               V_IDLANCDTMAIFIL := 'N'; V_IDLANCDTMAI := 'N'; V_IDLANCDTMENFIL := 'N'; V_IDLANCDTMEN := 'N';
               V_NRDIASAJUSFIL := NULL; V_NRDIASAJUS := NULL; V_NRDIASAJUSPDFIL := NULL; V_NRDIASAJUSPD := NULL;
         END;
         
         IF (V_IDLANCDTMAIFIL = 'N') AND (V_IDLANCDTMAI = 'N') AND (V_DATA > V_DTPROCESSA) THEN
            INSERE_LOGITEM(V_SEQLOGITEM);
            V_DESCERRO := 'Data de ajuste deve ser menor ou igual  data de processamento do OL.';
            
            INSERT INTO HMA_MONITORAINT(DSTABELA, CDDADOS, DSERRO, IDPROCESSO, SEQLOGITEM)
            VALUES('Conciliao de Estoque', V_CODINVENTARIO, V_DESCERRO, '3', V_SEQLOGITEM);

            V_ERRO := 'S';
         END IF;

         IF (V_IDLANCDTMENFIL = 'N') AND (V_IDLANCDTMEN = 'N') AND (V_DATA < V_DTPROCESSA) THEN
            INSERE_LOGITEM(V_SEQLOGITEM);
            
            V_DESCERRO := 'Data de ajuste deve ser maior ou igual  data de processamento do OL.';
            
            INSERT INTO HMA_MONITORAINT(DSTABELA, CDDADOS, DSERRO, IDPROCESSO, SEQLOGITEM)
            VALUES('Conciliao de Estoque', V_CODINVENTARIO, V_DESCERRO, '3', V_SEQLOGITEM);
            
            V_ERRO := 'S';
         END IF;

         IF (V_IDLANCDTMENFIL = 'S') AND (V_DATA < V_DTPROCESSA) THEN
            IF (V_DATA < (V_DTPROCESSA - V_NRDIASAJUSFIL)) THEN
               INSERE_LOGITEM(V_SEQLOGITEM);
               V_DESCERRO := 'Data do ajuste fora do perodo permitido.';
               
               INSERT INTO HMA_MONITORAINT(DSTABELA, CDDADOS, DSERRO, IDPROCESSO, SEQLOGITEM)
               VALUES('Conciliao de Estoque', V_CODINVENTARIO, V_DESCERRO, '3', V_SEQLOGITEM);

               V_ERRO := 'S';
            END IF;
         END IF;

         IF (V_IDLANCDTMEN = 'S') AND (V_DATA < V_DTPROCESSA) THEN
            IF (V_DATA < (V_DTPROCESSA - V_NRDIASAJUS)) THEN
               INSERE_LOGITEM(V_SEQLOGITEM);
               V_DESCERRO := 'Data do ajuste fora do perodo permitido.';
               
               INSERT INTO HMA_MONITORAINT(DSTABELA, CDDADOS, DSERRO, IDPROCESSO, SEQLOGITEM)
               VALUES('Conciliao de Estoque', V_CODINVENTARIO, V_DESCERRO, '3', V_SEQLOGITEM);

               V_ERRO := 'S';
            END IF;
         END IF;

         IF (V_IDLANCDTMAIFIL = 'S') AND (V_DATA > V_DTPROCESSA) THEN
            IF (V_DATA > (V_DTPROCESSA - V_NRDIASAJUSPDFIL)) THEN
               INSERE_LOGITEM(V_SEQLOGITEM);
               V_DESCERRO := 'Data do ajuste fora do perodo permitido.';
               
               INSERT INTO HMA_MONITORAINT(DSTABELA, CDDADOS, DSERRO, IDPROCESSO, SEQLOGITEM)
               VALUES('Conciliao de Estoque', V_CODINVENTARIO, V_DESCERRO, '3', V_SEQLOGITEM);

               V_ERRO := 'S';
            END IF;
         END IF;

         IF (V_IDLANCDTMAI = 'S') AND (V_DATA > V_DTPROCESSA) THEN
            IF (V_DATA > (V_DTPROCESSA - V_NRDIASAJUSPD)) THEN
               INSERE_LOGITEM(V_SEQLOGITEM);
               V_DESCERRO := 'Data do ajuste fora do perodo permitido.';
               
               INSERT INTO HMA_MONITORAINT(DSTABELA, CDDADOS, DSERRO, IDPROCESSO, SEQLOGITEM)
               VALUES('Conciliao de Estoque', V_CODINVENTARIO, V_DESCERRO, '3', V_SEQLOGITEM);

               V_ERRO := 'S';
            END IF;
         END IF;

         IF V_ERRO IS NULL THEN
            NOVO_CODIGO_SC('LANCTOEST' || V_CDFILIAL, V_NRLANCESTQ);

            INSERT INTO LANCTOESTOQ
               (CDFILIAL, NRLANCESTQ, CDOPERADOR, IDTPLANCTO,
                DTLANCESTQ, CDFILIMOVI, DSLANCESTQ, IDALTCUSMED,
                CDALMOXARIFE, CDLOCALESTOQ)
            VALUES
               (V_CDFILIAL, SUBSTR(V_NRLANCESTQ,11,10), V_CDOPERADOR, '1',
                V_DATA, V_CDFILIAL, 'Interface WMS ArMHAzena', 'N',
                ' ', ' ');
         END IF;

         IF V_IDORDIMPLANT = 'P' THEN
            V_IDORDEMCLC := '0';
         ELSE
            V_IDORDEMCLC := 'U';
         END IF;

         V_NRSEQUITEM := 1;
      END IF;

      IF V_ERRO IS NULL THEN

         BEGIN
            SELECT CDPRODUTO
              INTO V_CDPRODUTO
              FROM PRODUTO
             WHERE CDARVPROD = V_CODPRODUTO;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_CDPRODUTO := NULL;
         END;

         IF NOT V_CDPRODUTO IS NULL THEN
            INSERT INTO ITLANCTOEST
               (CDFILIAL, NRLANCESTQ, NRSEQUITEM, CDPRODUTO,
                QTTOTLANCTO, VRUNILANCTO, VRTOTLANCTO, IDTIPOMOVI,
                DTLANCMOVI, IDORDEMCLC, CDPRODMOVI, QTLANCTOEST,
                VRLANCTOBRUT, VRLANCTOEST, CDFILIMOVI, IDEVOLESTOQ,
                CDALMOXARIFE, CDLOCALESTOQ, NRLOTEESTQ, NRSUBLOTE, CDOPERADOR)
            VALUES
               (V_CDFILIAL, SUBSTR(V_NRLANCESTQ,11,10), LPAD(TO_CHAR(V_NRSEQUITEM), 4, '0'), V_CDPRODUTO,
                V_QTDEVALOR, 0, 0, '1',
                V_DATA, V_IDORDEMCLC, V_CDPRODUTO, V_QTDEVALOR,
                0, 0, V_CDFILIAL, 'N',
                ' ', ' ', ' ', ' ', V_CDOPERADOR);

            V_NRSEQUITEM := V_NRSEQUITEM + 1;
         ELSE
            INSERE_LOGITEM(V_SEQLOGITEM);   
            V_DESCERRO := 'Produto '|| V_CODPRODUTO || ' no cadastrado.';
            
            INSERT INTO HMA_MONITORAINT(DSTABELA, CDDADOS, DSERRO, IDPROCESSO, SEQLOGITEM)
            VALUES('Conciliao de Estoque', V_CODINVENTARIO, V_DESCERRO, '3', V_SEQLOGITEM);

            V_ERRO := 'S';
         END IF;
      END IF;
      
      IF V_ERRO IS NULL THEN
         INSERE_LOGITEM(V_SEQLOGITEM);
         INSERT INTO HMA_MONITORAINT(DSTABELA, CDDADOS, DSERRO, IDPROCESSO, SEQLOGITEM)
         VALUES('Conciliao de Estoque', V_CODINVENTARIO, V_ERRO, '3', V_SEQLOGITEM);
      END IF;
   END LOOP;
   
   P_ERRO := V_DESCERRO;
   
   COMMIT;
   CLOSE C_INV_ESTOQUE;
EXCEPTION
   WHEN OTHERS THEN
      IF C_INV_ESTOQUE%ISOPEN THEN
         CLOSE C_INV_ESTOQUE;
      END IF;
      
      INSERE_LOGITEM(V_SEQLOGITEM);
      
      V_DESCERRO := SQLERRM(SQLCODE);
      P_ERRO := V_DESCERRO;
      INSERT INTO HMA_MONITORAINT(DSTABELA, CDDADOS, DSERRO, IDPROCESSO, SEQLOGITEM)
      VALUES('Conciliao de Estoque', V_CODINVENTARIO, V_DESCERRO, '3', V_SEQLOGITEM);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('MHA_IMPORTA_INVENT_ESTOQUE','5.87.XXX'); END;
/