/******************************************************************************/
/******************************************************************************/
/* Trigger: DTULTATU_EXERFISICO              				   					   */
/* Tabela : EXERFISICO                               							      */
/*                                                                            */
/* Criao:                                                                   */
/* 02/02/2005 - Jonathan Abdon Silva												      */
/*                                                                    	      */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_EXERFISICO'  and
            type = 'TR'                   and
            u.uid = o.uid                 and
            u.name = USER)
  DROP TRIGGER DTULTATU_EXERFISICO
  GO


CREATE TRIGGER DTULTATU_EXERFISICO
ON EXERFISICO
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                              ( SELECT 'EXERFISICO', NULL, 'CDEXERFISICO='+CDEXERFISICO+';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE EXERFISICO
      SET DTULTATUEXFI = GETDATE()
      FROM INSERTED
      WHERE
         (EXERFISICO.CDEXERFISICO = INSERTED.CDEXERFISICO)
   END;
END;
GO



